/* Copyright (C) 2003, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * Local.java
 *
 *
 */

package uiuc.Jumbo.Compiler;

import uiuc.Jumbo.Jaemus.*;

/**
 * A class that holds information about a definition local to a method.
 * @version      1.0, Feb 14 2003
 * @author       Lars Clausen
 *
 */
public class Local {
    final String name;
    final Type type;
    final int flags;
    final Local next;

    public Local(String name, Type type, int flags, Local next) {
        this.name = name.intern();
        this.type = type;
        this.flags = flags;
        this.next = next;
    }
    public boolean isFinal() {
        return (flags & Flags.FINAL) != 0;
    }
    public String toString() {
        return name;
    }
    public boolean isLargeType() {
        return type == Type.long_type || type == Type.double_type;
    }
    /* Return length of linked list */
    public int size() {
        if (next == null) return 1;
        return next.size()+1;
    }
}
