/* Copyright (C) 2003, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * VarName.java
 *
 * A list of variable names.
 *
 */

package uiuc.Jumbo.Compiler;

import uiuc.Jumbo.Jaemus.*;

/**
 * A class that holds information about a method-local variable's name.
 * @version      1.0, 6 Feb 2003
 * @author       Lars Clausen
 *
 */

public class VarName {
    final String name;
    final boolean isFinal;
    final VarName next;

    public VarName(String name, boolean is_final, VarName next) {
        this.name = name.intern();
        this.isFinal = is_final;
        this.next = next;
    }

    public String toString() {
        return name+(next==null?"":", "+next);
    }
}
    
