/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * ExceptionInfo.java
 *
 *
 */

package uiuc.Jumbo.Jaemus;

import java.io.*;

/**
 * The exception information used inside a Code attribute
 * @version      1.0,  3 Oct 2001
 * @author       Lars Clausen
 *
*/

public class ExceptionInfo implements Emittable {
    Instr start, end, handler;
    String catch_type;
    Constant catch_type_constant;
    public ExceptionInfo(Instr start, Instr end, Instr handler, String catch_type) {
        this.start = start;
        this.end = end;
        this.handler = handler;
        this.catch_type = catch_type;
    }
    
    public void prepareForEmit(ConstantPool c) {
        catch_type_constant = c.addClass(catch_type);
    }

    public void emitTo(DataOutputStream o) throws IOException {
        o.writeShort(start.offset);
        o.writeShort(end.offset+end.size());
        o.writeShort(handler.offset);
        catch_type_constant.emitIndex(o);
    }
}

/* End of class ExceptionInfo*/
