/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * InterfaceInfo.java
 *
 *
 */

package uiuc.Jumbo.Jaemus;

import java.io.*;
import uiuc.Jumbo.Util.*;

/**
 * Class holding information about an interface
 * @version      1.0,  2 Oct 2001
 * @author       Lars Clausen
 *
*/

// XXX Fixme:  This doesn't do anything right.
public class InterfaceInfo extends ClassInfo {
    public InterfaceInfo(String name) {
        this(0, name, null);
    }

    public InterfaceInfo(int flags, String name) {
        this(flags | Flags.INTERFACE, name, null);
    }

    public InterfaceInfo(String name, MonoList superinterfaces) {
        this(0, name, superinterfaces);
    }

    public InterfaceInfo(int flags, String name, MonoList superinterfaces) {
        super(flags | Flags.INTERFACE, name);
        if (superinterfaces != null)
            this.implementees = superinterfaces;
    }

    /* Create a representation of an existing interface */
    public InterfaceInfo(Class c) {
        super(c);
        Class[] supers = c.getInterfaces();
        MonoList superlist = new ArrayMonoList();
        for (int i = 0; i < supers.length; i++) {
            superlist.add(supers[i].getName().replace('.', '/'));
        }
        if (superlist != null)
            this.implementees = superlist;
    }

    public boolean isInterface() {
        return true;
    }

    public void prepareForEmit(ConstantPool c) {
        super.prepareForEmit(c);
    }

    public MonoList getSuperInterfaces() {
        if (implementees == null) {
            implementees = new ArrayMonoList();
        }
        return implementees;
    }
}

/* End of class InterfaceInfo*/
