/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * ClassExpression.java
 *
 */

package uiuc.Jumbo.Ast;

import uiuc.Jumbo.Util.ArrayMonoList;

/**
 * Node handling <type>.class expressions
 * @version      1.0, 26 Feb 2003
 * @author       Lars Clausen
 *
*/

public class ClassExpression extends Expression {
    public ClassExpression(String s) {
        setName(s);
    }

    public ClassExpression(Type t) {
        setName(t.toString());
    }

    public ClassExpression(Identifier i) {
        setName(i.toString());
    }

    private void setName(String s) {
        classname = s;
    }

    public String toString() {
        return classname+".class";
    }

    public IR toIR() {
        return IR.make("dotClass", new ArrayMonoList()
                       .add(IR.make(classname)));
    }

    public void toSource() {
        print(classname);
        print(".class");
    }

    public Type getType(ClassEnv loader) {
        return new Type("java.lang.Class");
    }

    /* Fields */
    String classname;
}

/* End of class ClassExpression*/
