/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;

/**
 * Represents an identifier string used by the ast.
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */

public class IdentifierString implements java.io.Serializable{
    //------------- CONSTRUCTORS
    /**
     * Creates an AstString with a particular string value.
     */
    public IdentifierString(String value) { 
        string = value;
    }

    public String toUnquotedString() {
        return string;
    }

    public String toString() {
        return string;
    }

    public String getString() {
        return string;
    }

    public boolean equals(Object o) {
        if (!(o instanceof IdentifierString)) return false;
        return string.equals(((IdentifierString)o).string);
    }

    public IR toIR() {
        return IR.make(string);
    }

    /** Return a hashcode that is constant for this IdentifierString.
     * Different instances with the same string are considered equal.
     */
    public int hashCode() {
        return string.hashCode();
    }

    //------------- INSTANCE VARIABLES
    protected String string;
}
