/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;

/**
 * Represents an unknown case group within a switch statement.
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */

public class UnknownSwitchCaseBlock extends SwitchCaseBlock {
   /**
    * @param c   code as a string
    */
   public UnknownSwitchCaseBlock( String c ) {
      super(null);
      constructor = c;
   }

   /**
    * Indicates whether this is a default switch case.
    *
    * @return true if this case group is a default, false otherwise.
    */
   public boolean isDefault() {
      return false;
   }

   /**
    * constructors.
    */
   protected String constructor;
}
