/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * See the file LICENSE for details.
 */
public class FieldAccess {
    public int instance_var_public;
    protected int instance_var_protected;
    private int instance_var_private;

    public FieldAccess() { 
        instance_var_public = 11;
        instance_var_protected = 12;
        instance_var_private = 13;
    }

    public void testInstanceFieldAccess() {
        System.out.println( "Plain public var: " + instance_var_public );
        System.out.println( "Plain protected var: " + instance_var_protected );
        System.out.println( "Plain private var: " + instance_var_private );

        System.out.println( "ThisDot public var: " 
                                + this.instance_var_public );
        System.out.println( "ThisDot protected var: " 
                                + this.instance_var_protected );
        System.out.println( "ThisDot private var: " 
                                + this.instance_var_private );
    }

    public static void main(String argv[]) {
        FieldAccess fa = new FieldAccess();

        fa.testInstanceFieldAccess();

        System.out.println( "fa. public var: " 
                                + fa.instance_var_public );
        System.out.println( "fa. protected var: " 
                                + fa.instance_var_protected );
        System.out.println( "fa. private var: " 
                                + fa.instance_var_private );
    }
}

