/* This test file illustrates how to use abstraction for 
 * single parameter/arguments, 
 * and parameter/argument lists.
 */

import uiuc.Jumbo.Compiler.*;
import uiuc.Jumbo.Util.*;
import uiuc.Jumbo.Jaemus.*;

public class ParamList
{
    public static void test1(){
	MonoList a = new ArrayMonoList();
	a.add($Args<1, " PASSED!">$);

	MonoList p = new ArrayMonoList();
	p.add($Params<int arg1, String arg2>$);

	Code c = $<
	    public class Temp1 implements ITemp {
		public String message(){
		    return test(`Args(a));
		}
		
		public String test(`Params(p)){
		    return "Test" + arg1 + arg2;
		}
	    }
	>$;
	ITemp obj = (ITemp) c.create("Temp1");
	System.out.println(obj.message());	
    }
    public static void test2(){
	Code a1 = $<2>$;
	Code a2 = $<" PASSED!">$;

	String p1 = "arg1";
	String p2 = "arg2";

	Code c = $<
	    public class Temp2 implements ITemp {
		public String message(){
		    return test(`Expr(a1), `Expr(a2));
		}
		
		public String test(`Type(Type.int_type) `Name(p1), `Type(new Type("String")) `Name(p2)){
		    return "Test" + `Name(p1) + arg2;
		}
	    }
	>$;
	ITemp obj = (ITemp) c.create("Temp2");
	System.out.println(obj.message());	
    }

    public static void test3(){
	MonoList a = new ArrayMonoList();
	MonoList p = new ArrayMonoList();

	Code c = $<
	    public class Temp3 implements ITemp {
		public String message(){
		    return test(`Args(a));
		}
		
		public String test(`Params(p)){
		    return "Test3 PASSED!";
		}
	    }
	>$;
	ITemp obj = (ITemp) c.create("Temp3");
	System.out.println(obj.message());	
    }

    public static void main(String[] args){
	test1();
	test2();
	test3();
    }
}

interface ITemp{
    public String message();
}
