/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * Util.java
 *
 *
 */

package uiuc.Jumbo.Util;

import java.util.*;

/**
 * Various utility functions
 * @version      1.0, 21 Oct 2001
 * @author       Lars Clausen
 *
*/

public class Util {
    public static String conjoin(List l, String sep) {
        String res = "";
        for (Iterator i = l.iterator(); i.hasNext(); ) {
            res += i.next();
            if (i.hasNext()) res += sep;
        }
        return res;
    }

    public static String conjoin(MonoList l, String sep) {
        String res = "";
        for (Iterator i = l.iterator(); i.hasNext(); ) {
            res += i.next();
            if (i.hasNext()) res += sep;
        }
        return res;
    }
    public static String conjoin(Object[] l, String sep) {
        String res = "";
        for (int i = 0; i < l.length; i++) {
            res += l[i];
            if (i < l.length-1) res += sep;
        }
        return res;
    }

    public static List unjoin(String s, String sep) {
	StringTokenizer st = new StringTokenizer(s, sep);
	List l = new ArrayList();
	while (st.hasMoreTokens()) {
	    l.add(st.nextToken());
	}
	return l;
    }

    public static List list() { return new ArrayList(); }
    public static List list(Object o) {
        List l = new ArrayList(1); l.add(o); return l; 
    }
    public static List list(Object o1, Object o2) {
        List l = new ArrayList(2);
        l.add(o1);
        l.add(o2);
        return l; 
    }
    public static List list(Object o1, Object o2, Object o3) {
        List l = new ArrayList(3);
        l.add(o1);
        l.add(o2);
        l.add(o3);
        return l; 
    }
    public static List list(Object o1, Object o2, Object o3, Object o4) {
        List l = new ArrayList(4);
        l.add(o1);
        l.add(o2);
        l.add(o3);
        l.add(o4);
        return l; 
    }
    public static List list(Object o1, Object o2, Object o3, Object o4, Object o5) {
        List l = new ArrayList(5);
        l.add(o1);
        l.add(o2);
        l.add(o3);
        l.add(o4);
        l.add(o5);
        return l; 
    }
}

/* End of class Util*/
